; -*- Scheme -*-

(pool-rules "Training game"

			; Game Options

	    'number-of-balls 3

	    'number-of-players '(1 3)

	    'help-file "game_rules.html"
	
	    'score 
	      '((counter	"Points"))

			; declare safe-to-undo
	    'safe-to-undo #t

	    'event-mask '(ball-ball-collision ball-jump-off)

			; Functions

	    'table-setup
	      (lambda ()
		(table-new table/carom)
		(cushion-height (+ carom-ball-radius (mm 2)))
		      ; set skins
		(ball-set-skin 0 "1. ball" 'white-ball-with-black-mark 'carom-ball)
		(ball-set-skin 1 "2. ball" 'red-ball 'carom-ball)
		(ball-set-skin 2 "3. ball" 'white-ball-blue-strip 'carom-ball)

		(mark-line #(10 0) #(0 10))
		(mark-point #(95 5) (cm 1)))

	    'new-game
	      (lambda ()

		(place-ball 0 (vector (cm 50) (cm 66)))
		(place-ball 1 (vector (cm 50) (cm 100)))
		(place-ball 2 (vector (cm 50) (cm 120)))
;		(place-ball 3 (vector (cm 70) (cm 120)))
;		(place-ball 4 (vector (cm 30) (cm 133)))

		(place-cue  0 (vector -90 0)))

	    'end-of-shot
	      (lambda (last-state game-state balls-out)
		(DebugDisplayEndOfShot last-state game-state balls-out)
		(or (eq? last-state 'after-first-hit)
		    (game-next-player))
		(for-each ball-in-hand balls-out))

	    'event-handler
	      (lambda (event-type info1 info2 state game-state)
		(DebugDisplayEvent event-type info1 info2 state game-state)
		(case event-type
		  ((ball-ball-collision)
		   (case state
		     ((after-first-hit)
		      (game-add-point)
		      (game-reward)
		      'after-first-hit)
		     ((faul)
		      state)
		     (else
		      'after-first-hit)))
		  ((ball-jump-off)
		   (game-faul)
		   (game-ball-out)
		   'faul))))
