#ifndef __POOL_CUE_H__
#define __POOL_CUE_H__

typedef struct
{
  char		*name;
  dbl		length;
  dbl		cap_length;

  dbl		top_width;
  dbl		bottom_width;
} PoolCueTypeInfo;

typedef struct
{
  PoolCueTypeInfo	*cue_type;
  Skin			*cue_skin;

  int			ball;				/* on which ball we are shooting ... */

  dbl			alfa, beta;
  dbl			cue_center_distance;

  dbl			center_of_rotation [3];		/* center of cue rotation */

  dbl			top [3];		/* c */	/* cue's top */
  dbl			up [3];			/* c */
  dbl			right [3];		/* c */
  dbl			orientation [3];	/* c */	/* which direction cue is pointing */

  dbl			adjust [2];			/* adjustment of cue's position */
  dbl			adjusted_top [3];
  dbl			adjusted_bottom [3];

  /* flags */
  guint			rebuild_gl_list : 1;		/* set when type or skin changes */
} PoolCue;

void cue_boom (dbl *oldpos, dbl *newpos, dbl speed);
void cue_motion (PoolCue *cue, dbl delta_y, dbl speed);
void cue_rotate (PoolCue *cue, dbl h_change, dbl v_change); 
void cue_adjust (PoolCue *cue, dbl x, dbl y);

void cue_set_ball (PoolCue *cue, int ball_id);

void cue_update_orientation (PoolCue *cue);
void cue_update_position (PoolCue *cue);

void cue_set_orientation (PoolCue *cue, dbl alfa, dbl beta);
void cue_reset_position (PoolCue *cue);
void cue_get_new_position (PoolCue *cue, dbl new_cue_center_distance,
			   dbl *top, dbl *adjusted_top, dbl *adjusted_bottom);


extern GList		*pool_cue_type_list;
extern PoolCue		 pool_cue;
extern dbl		 pool_cue_mouse_speed;

void cue_recalc_hints (void *);

#endif
