#ifndef __FYJIK__
#define __FYJIK__

#include "animation.h"
#include "pool.h"

#define MAX_PYTHIE_COLS		10

/* returns whether cue hits _any_ ball 
 *  + 1 hit
 *    0 nothing happend
 *  - 1 table is damaged :)
 */

gint pool_cue_ball (PoolBallSpaceInfo *, int nof_bals,   
		    dbl *startpos, dbl *endpos);



/* computes all trajectories of all balls */

void pool_big_mover (PoolBallSpaceInfo *, int nof_bals, int nop,
		     dbl *startpos, dbl *endpos, dbl time, dbl cue_roughness,
		     Animation **newanim );

void pool_fyjik( Animation *anim, int nop, dbl cue_burr );

void pool_pythie (PoolBallSpaceInfo *, int nof_balls, 
		  int active_ball, dbl *cue_orient);

extern dbl ** pool_pythie_positions;
extern int  * pool_pythie_counts;

/* for table edges dwaing */

extern dbl ** table_sides;
extern dbl  * hole_cuts;
extern int  * counts;
extern int    nof_edges;

void generate_table();
void planeNormal( dbl **v, dbl *n );

/* for ball in hand */

int ball_out_of_table (PoolBallSpaceInfo *, int);
int ball_in_hole (PoolBallSpaceInfo *);

#endif
