#ifndef __FYJPRIV__
#define __FYJPRIV__

/* special data for fyjik */

#define Sphere			PoolBallSpaceInfo

#define G			981 /* cm/s^2 */

#define TABLE_H			pool_table.table_height

#define DEFAULT_STEPS		POOL_DEFAULT_BIG_MOVER_FPS
#define ADD_STEPS		(2 * (DEFAULT_STEPS))
#define DEFAULT_EVENTS		20
#define ADD_EVENTS		20
#define CUT_FRAME		2000
#define ACCUR			0.0001
#define NEAR_TABLE		0.1
#define DONT_JUMP		0.1
#define ENDER			0.05
#define CUE_BALL_TIME_COL	0.01
#define CUE_MAX_POWER		1000.0

#define STATE_FYJIK		1
#define STATE_PYTHIE		2

#define MAX_BALLS		100

#define DED_HRIB		1/*table*/ + 6 /* cue */ 
#define CUE_SHOCK		5 /* cue back shock for good computing with cue :) */
#define HOLE_DEPTH		POOL_TABLE_HOLE_DEPTH
#define FLOOR_DEPTH		-100

#define PREC_BACK_SHOCK		0.04
#define PREC_BACK_SHOCK_EDGE	0.01
#define MAGIC_IGNORANT		400
#define BALL_MINICUK		0.01
#define EPS			10.0

#define DT			(1.0 / (dbl)DEFAULT_STEPS)

#define SWAP(A, B, C)		do { (C) = (A); (A) = (B); (B) = (C); } while(0)

#define CT(T)			(cum_tr + (T) * cum_scl)
#define NT(T)			(((T) - cum_tr) / cum_scl)

typedef struct
{
  dbl		time;
  Animation	*ani;
  int		round;

  /* for debbug infos */
  Sphere	*act_sphs;
} bang_info;


typedef struct
{
  /* aux. variables for storing partial results... */
  int		type;

  dbl		n [3];
  dbl		r [3];
  dbl		coef;
  dbl		t;
} PernikovaChaloupka;

typedef struct
{
  dbl	t;
  dbl	n[3];
} Babovicka;

typedef union
{
  PernikovaChaloupka 	ch;
  Babovicka		b;
} DedecekHribecek;

typedef struct
{
  dbl	t;
  int	idx;
} Bajaja;

typedef struct
{
  dbl	t;
  dbl	p1[3];
  dbl	p2[3];
  dbl	v1[3];
  dbl	v2[3];
} Snehurka;

void sphere2plane( Sphere *sph, dbl *old_pos, DedecekHribecek *hrib, int hrib_line_len, int ns,
		   int ids, dbl **v, int nv, int idp );

int is_one_static( Sphere *sph, dbl dt );
#endif

