/* game events
   $Id: gameevent.c,v 1.4 2000/02/26 21:15:18 0rfelyus Exp $

   Copyright (C) 1999 Radek Doulik <rodo@pha.eridan.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "gameevent.h"

GameEvent *
game_event_new (gint t, gpointer * d)
{
	GameEvent * ge;

	ge = g_new (GameEvent, 1);

	ge->type = t;
	ge->data = d;

	return ge;
}

EventCueXBall *
event_cue_x_ball_new (dbl *t, dbl *n, dbl s)
{
	EventCueXBall * ev = g_new (EventCueXBall, 1);
	gint i;

	for (i=0; i<3; i++) {
		ev->top    [i] = t [i];
		ev->newpos [i] = n [i];
	}
	ev->speed    = s;

	return ev;
}

EventScore *
event_score_new (gint c, gint d)
{
	EventScore * ev = g_new (EventScore, 1);

	ev->counter = c;
	ev->data    = d;

	return ev;
}

EventResetScore *
event_reset_score_new (gint c, gint pid)
{
	EventResetScore * ev = g_new (EventResetScore, 1);

	ev->counter = c;
	ev->data    = NULL;
	ev->pid = pid;

	return ev;
}
