/* widget for scores displayed using color balls
   $Id: gnome-score-balls.h,v 1.12 2000/02/29 13:49:42 rodo Exp $

   Copyright (C) 1999 Radek Doulik <rodo@pha.eridan.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __GNOME_SCORE_BALLS_H__
#define __GNOME_SCORE_BALLS_H__

typedef struct _GnomeScoreBalls  GnomeScoreBalls;
typedef struct _GnomeTulpasScore GnomeTulpasScore;

#include <gtk/gtk.h>
#include "score.h"
#include "game.h"

#define BALL_PIXMAP_WIDTH    19
#define BALL_OFF             (BALL_PIXMAP_WIDTH+1)
#define BALLS_PER_LINE       5

struct _GnomeScoreBalls
{
	GnomeTulpasScore *gs;
	Score     * score;

	GtkWidget *  area;
	GdkPixmap *  pixmap;
	GdkPixmap ** balls;
	gint         n;
	gint         refresh;

	gint lines;
	gint active;
};

GnomeScoreBalls * gnome_score_balls_new        (GnomeTulpasScore *, Score *);
void              gnome_score_balls_refresh    (GnomeScoreBalls *);

struct _GnomeTulpasScore
{
	GtkWidget *  frame;
	GtkWidget *  vbox;
	GtkWidget ** tab;
	GtkWidget ** ball_on;
	GtkWidget ** ball_frame;

	Game * game;
	gint players;
	gint active_player;

	GnomeScoreBalls ** score;
	GtkWidget       ** label;

	/* pixmaps of balls for pocketed ball counter */
	GdkPixmap ** ball_pixmap;
	GdkBitmap ** ball_bitmap;
};

GnomeTulpasScore * gnome_tulpas_score_new        (Game *g);
void               gnome_tulpas_score_refresh    (GnomeTulpasScore *s);
void               gnome_tulpas_score_set_player (GnomeTulpasScore *s, gint);
void               gnome_tulpas_score_ball_on    (GnomeTulpasScore *s, gint);

#endif
