
/* gtulpas.h -- app
   $Id: gtulpas.h,v 1.9 2000/02/28 16:03:35 rodo Exp $

   Copyright (C) 1999 Radek Doulik <rodo@pha.eridan.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __G_TULPAS_H__
#define __G_TULPAS_H__

typedef struct _GTulpas     GTulpas;

#include "gnome-poolview.h"
#include "gnome-ball.h"
#include "gnome-score-balls.h"
#include "game.h"
#include <gtk/gtk.h>
#include <libgnomeui/gnome-appbar.h>

struct _GTulpas
{
	GtkWidget  * app;
	GtkWidget  * table;

	GtkWidget  * ugly_box;
	GtkWidget  * paned;
	GtkWidget  * mv_vbox;
	GtkWidget  * sc_vbox;
	GtkWidget  * ball_hbox;

	GnomeAppBar   *  bar;

	GnomePoolView *  main_view;		/* main view */
	GnomePoolView *  mini_view [3];         /* three miniviews in the main window */
	GList	      *  extra_view_list;       /* extra views in separate windows */

	GnomeBall        * ball;
	GnomeTulpasScore * score;

	gint extra_views;
	gint mini_views;

	GList * views;                          /* list of all views - main, mini, extra */

	Game  * game;
	gint    game_id;
};

extern GTulpas * gtulpas;

GTulpas * gtulpas_new ();
void gtulpas_fill_table            (GTulpas *gt);
void gtulpas_create_contents       (GTulpas *gt);
void gtulpas_create_and_load       (GTulpas *gt, gchar *prefix);
void gtulpas_save                  (GTulpas *gt, gchar *prefix);
void gtulpas_layout_change         (GTulpas *gt);
void gtulpas_guile_init            (void);
void gtulpas_select_game           (GTulpas *gt, Game *);
void gtulpas_select_game_by_id     (GTulpas *gt, gint id);
void gtulpas_score_refresh         (GTulpas *gt);

void gtulpas_answers_undo_sensitivity (int sensitivity);
void gtulpas_undo_sensitivity (int sensitivity);
/*
 *
 *	Messages for player
 */

void gtulpas_status_start (char *message);
void gtulpas_status_end (void);
void gtulpas_status_message (char *message);
void gtulpas_status_clear (void);

void gtulpas_glue_error (char *errstr, int length);
void gtulpas_glue_error_show_console (void);

#endif
