#ifndef __POOL_GLUE_H__
#define __POOL_GLUE_H__

#include <libguile/throw.h>


#define GLUE_STRDUP(S)			g_strndup (SCM_CHARS (S), SCM_LENGTH (S))
#define SAFE_SCHEME_CALL(FUNC, DATA)				        \
    scm_internal_stack_catch (SCM_BOOL_T,				\
			(scm_catch_body_t) (FUNC), (void *)(DATA),	\
			glue_catch_handler, NULL)		

typedef struct {
  SCM			symbol;
  char		       *name;		
  int			value;
} glue_enum_item;

typedef struct {
  glue_enum_item	*sorted_by_symbol;
  glue_enum_item	*sorted_by_value;

  int			 num_of_items;
} glue_enum_info;

SCM glue_safe_apply (SCM function, SCM args);
SCM glue_catch_handler (void *data, SCM tag, SCM throw_args);

SCM glue_safe_call0 (SCM function);
SCM glue_safe_call1 (SCM function, SCM arg1);
SCM glue_safe_call2 (SCM function, SCM arg1, SCM arg2);
SCM glue_safe_call3 (SCM function, SCM arg1, SCM arg2, SCM arg3);
SCM glue_safe_call4 (SCM function, SCM arg1, SCM arg2, SCM arg3, SCM arg4);

void glue_enum_info_init (glue_enum_info *info);
SCM  glue_enum_value2scm (int key_value, glue_enum_info *info);
int  glue_enum_scm2value (SCM key_symbol, glue_enum_info *info);
int  glue_enum_scmlist2value (SCM list, glue_enum_info *info, int narg, const char *name);

extern Game*	    inside_set_rules;

void glue_process_anim_event (Animation *, AnimEvent *event);
void glue_call_end_of_shot (Game *game);

void glue_game_state_backup (Game *game);
void glue_game_state_restore (Game *game);

	/* some really dirty stuff : */
void glue_gc_disable (void);
void glue_gc_enable (void);

void glue_debug_console (void);
void glue_load_scheme_files (void);

#endif
