#ifndef __POOL_FEEDGL_H__
#define __POOL_FEEDGL_H__

#include "pool.h"
#include "render.h"
#include "query.h"

#define POOL_PICK_WIDTH		3
#define POOL_PICK_HEIGHT	3		

#define LOD_TO_SPHERE_PREC(X)	(3 * ((X) + 1))

typedef struct {
  int		refcount;
  LOD_array	lists;
} LOD_info;

LOD_info*   LOD_ref (LOD_info *);
void        LOD_unref (LOD_info *);
void	    LOD_finish_ball (PoolBall *);

int	    pool_view_make_current (PoolViewGL *view);

void pool_GL_init (void);
void pool_view_do_redraw (PoolViewGL *);
int  pool_view_do_select (PoolViewGL *, int , int , QueryType);
void pool_view_GL_finish (PoolViewGL *viewdata);

void pool_view2table_coords (PoolViewGL *data, PoolBallSpaceInfo *,
			     int win_x, int win_y);

#ifdef __GAME_H__
void render_score_ball (Game *g, int ball_id, int, int, GdkPixmap **, GdkBitmap **);
#endif


#endif
