#ifndef __POOL_KEYS_H__
#define __POOL_KEYS_H__


#define POOL_KEY_MASK	(GDK_SHIFT_MASK | GDK_CONTROL_MASK | GDK_MOD1_MASK | GDK_MOD4_MASK)

typedef enum {
  PKB_NONE,

  PKB_ZOOM_IN,
  PKB_ZOOM_OUT,		
  
  PKB_LEFT, 
  PKB_RIGHT,	
  
  PKB_ROTATE_LEFT, 
  PKB_ROTATE_RIGHT,

  PKB_UP, 
  PKB_DOWN,	
  
  PKB_ROTATE_UP, 
  PKB_ROTATE_DOWN,

  PKB_MOD_ROTATE,
  PKB_MOD_SPIN,

  PKB_MOD_ZOOM,
  PKB_MOD_PAN,

  PKB_MOD_CUE_MOTION,
  PKB_MOD_CUE_ROTATE,

  PKB_MOD_MOVE_BALL,

  PKB_STOP_SPIN,
  PKB_TOGGLE_HINT,

  PKB_VIEW_BIND_CUE,

  PKB_VIEW_1,
  PKB_VIEW_2,
  PKB_VIEW_3,
  PKB_VIEW_4,
  PKB_VIEW_5,
  PKB_VIEW_6,
  PKB_VIEW_7,
  PKB_VIEW_8,
  PKB_VIEW_9
} PoolKeyAction;	

typedef enum
{
  PMod_NOTHING		 = 0,
  PMod_ROTATE		 = (1<<0),
  PMod_SPIN		 = (1<<1),
  PMod_ZOOM		 = (1<<2),
  PMod_PAN		 = (1<<3),
  PMod_CUE_MOTION	 = (1<<4),
  PMod_CUE_ROTATE	 = (1<<5),
  PMod_BALL_IN_HAND	 = (1<<6),
  PMod_MOVE_BALL	 = (1<<7)
} PoolModAction;

typedef struct {
  guint		keyval;
  guint		state;
  PoolKeyAction action;
} PoolKey;

void 	 pool_key_init_default (void);
void	 pool_key_add (guint keyval, guint state, PoolKeyAction action);
PoolKey* pool_key_lookup (guint keyval, guint state);
void	 pool_key_remove (PoolKey *);
void	 pool_key_remove_all (void);

#endif
