/* properties and properties dialog
   $Id: properties.h,v 1.6 2000/01/18 20:50:06 0rfelyus Exp $

   Copyright (C) 1999 Radek Doulik <rodo@pha.eridan.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __PROPERTIES_H__
#define __PROPERTIES_H__

#include <glibconfig.h>

typedef struct _GTulpasProperties    GTulpasProperties;
typedef struct _PoolViewProperties   PoolViewProperties;

enum Shading {
	SH_NONE,
	SH_LINEAR,
	SH_GORAUD,
};

enum LevelOfDetail {
	LOD_HIGH,
	LOD_NORMAL,
	LOD_LOW,
};

struct _GTulpasProperties
{
	/* layout */

	gint show_mini_views;
	gint show_game_status;

	/* graphics */

	gint glu_tesselator_ok;
	gint funny_pockets;
	gint render_table_outline;


	gint draw_shadows;
	gint real_cue_shadows;

	gint shading;
	gint lod;

	/* animation */
	gdouble blink_duration;
};

extern GTulpasProperties properties;

void properties_load (GTulpasProperties *prop, gchar *prefix);
void properties_save (GTulpasProperties *prop, gchar *prefix);

void properties_show ();

#endif
