/* queries3 1999/11/14 19:01:36 0rfelyus
   $Id: query.h,v 1.4 2000/01/17 18:24:19 0rfelyus Exp $

   Copyright (C) 1999 Daniel Skarda <0rfelyus@suse.cz>
   Copyright (C) 1999 Radek Doulik <rodo@suse.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __QUERY_H__
#define __QUERY_H__

#include <glibconfig.h>
#include <libguile/tags.h>

typedef struct _Query Query;

typedef enum
{
  Query_Ball,
  Query_Pocket,
  Query_Player
} QueryType;

struct _Query
{
  QueryType	type;

  int		response;
  char	      * name;
  char	      * prompt;
  char          * error;

  SCM	when_func;
  SCM	valid_func;
};

int query_needs_answer (Query *query, int round, int player_id);
int query_is_valid     (Query *query, int round, int player_id, int answer);

GList *query_scm2list  (SCM ob, int argn, const char *procname);
void   query_free      (GList *qlist);

#define	QUERY_DO_CALL	        -1
#define	QUERY_DO_IGNORE	        -2

#endif
