/* score
   $Id: score.c,v 1.5 2000/02/23 16:33:32 rodo Exp $

   Copyright (C) 1999 Radek Doulik <rodo@suse.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "score.h"
#include <string.h>

Score *
score_new (ScoreType t, Game *game, gchar *name)
{
	Score *ns = g_new (Score, 1);
	gint i;

	ns->type = t;
	ns->game = game;
	ns->name = g_strdup (name);

	if (t == SVBalls) {
		ns->n = game->balls_nof;
		ns->sunken = g_new (gint, ns->n);
	} else
		ns->n = 0;

	score_reset (ns);
	return ns;
}

void
score_reset (Score *s)
{
	gint i;

	s->hits = 0;
	s->sunken_count = 0;
	/* clear */
	for (i=0; i<s->n; i++)
		s->sunken [i] = 0;
}

void
score_inc (Score *s, gint i)
{
	g_assert (s->type != SVBalls);

	s->hits += i;
}

void
score_sunk (Score *s, gint color)
{
	gint i;

	g_assert (s->type == SVBalls);
	g_assert (s->sunken_count < s->n);

	for (i=0; i<s->sunken_count; i++)
		if (s->sunken [i] == color) {
			g_warning ("already pocketed ball\n");
			return;
		}

	s->sunken [s->sunken_count] = color;
	s->sunken_count++;
}
