/* score
   $Id: score.h,v 1.6 2000/02/28 09:27:44 rodo Exp $

   Copyright (C) 1999 Radek Doulik <rodo@suse.cz>

   This file is part of gmap.

   gmap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   gmap is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with gmap; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __SCORE_H__
#define __SCORE_H__

typedef struct _Score Score;
typedef enum   _ScoreType ScoreType;

#include <glib.h>
#include <game.h>

enum _ScoreType {

	SNumbers,
	SBalls,
	SFauls,
	SVBalls,
	ScoreTypeMax,
};

struct _Score
{
	ScoreType type;

	Game  * game;
	gchar * name;

	gint   hits;
	gint * sunken;
	gint   n;

	gint sunken_count;
};

Score * score_new   (ScoreType, Game*, gchar *);
void    score_inc   (Score *, gint);
void    score_sunk  (Score *, gint);
void    score_reset ();

#endif
