#ifndef __TABLE_H__
#define __TABLE_H__

typedef struct
{
  Skin		       *skin;
  int			hid;

  dbl			p[2];
  dbl			radius;
} TableHole;

typedef enum
{
  TableMark_Point,
  TableMark_Line,
  TableMark_Arc,
  TableMark_Diamond
} TableMarkType;

typedef struct
{
  TableMarkType		mark_type;
  Skin		       *skin;

  dbl			p1 [2];
  dbl			p2 [2];

  dbl			dparam;
  int			iparam;

  void		       *data;
} TableMark;

/* FIXME */
#define DEFAULT_TABLE_HEIGHT	10
#define POOL_TABLE_HOLE_DEPTH  -30
#define DEFAULT_TABLE_DEPTH    -40

typedef struct
{
  Skin			*skin;

  dbl			*vertices;
  int			nof_vertices;

  dbl			*outer_vertices;
  Skin			*outer_skin;
  int			nof_outer_vertices;

  TableHole		*holes;
  int			nof_holes;

  dbl			table_height;
  GList		        *mark_list;

  guint			update_view_info  : 1;    /* table changed and should be regenerated */
  guint			update_fyjik_info : 1;
} PoolTable;

extern PoolTable	  pool_table;

#ifdef INCLUDE_RENDER_DEFS

void	table_render_fake_hole (PoolViewGL *data, TableHole *hole, dbl z);
void	table_render (PoolViewGL *data, int allow_fake_holes);

#endif
#endif
